---
title: TypedArray.prototype.subarray()
slug: Web/JavaScript/Reference/Global_Objects/TypedArray/subarray
tags:
  - JavaScript
  - Method
  - Prototype
  - TypedArray
  - TypedArrays
---
<div>{{JSRef}}</div>

<p>The <strong><code>subarray()</code></strong> method returns a new <em>TypedArray</em> on the same {{jsxref("ArrayBuffer")}} store and with the same element types as for this <em>TypedArray</em> object. The begin offset is <strong>inclusive</strong> and the end offset is <strong>exclusive</strong>. <em>TypedArray</em> is one of the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/TypedArray#TypedArray_objects">typed array types</a>.</p>

<div>{{EmbedInteractiveExample("pages/js/typedarray-subarray.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>typedarr</var>ay.subarray([<var>begin</var>[, <var>end</var>]])
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>begin</var></code> {{optional_inline}}</dt>
 <dd>Element to begin at. The offset is inclusive. The whole array will be included in the new view if this value is not specified.</dd>
 <dt><code><var>end</var></code> {{optional_inline}}</dt>
 <dd>Element to end at. The offset is exclusive. If not specified, all elements from the one specified by <code><var>begin</var></code> to the end of the array are included in the new view.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A new {{jsxref("TypedArray")}} object.</p>

<h2 id="Description">Description</h2>

<p>The range specified by <code><var>begin</var></code> and <code><var>end</var></code> is clamped to the valid index range for the current array; if the computed length of the new array would be negative, it's clamped to zero. If either <code><var>begin</var></code> or <code><var>end</var></code> is negative, it refers to an index from the end of the array instead of from the beginning.</p>

<p>Also note that this is creating a new view on the existing buffer; changes to the new object's contents will impact the original object and vice versa.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_the_subarray_method">Using the subarray() method</h3>

<pre class="brush:js notranslate">var buffer = new ArrayBuffer(8);
var uint8 = new Uint8Array(buffer);
uint8.set([1,2,3]);

console.log(uint8); // Uint8Array [ 1, 2, 3, 0, 0, 0, 0, 0 ]

var sub = uint8.subarray(0,4);

console.log(sub);   // Uint8Array [ 1, 2, 3, 0 ]
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-%typedarray%.prototype.subarray', 'TypedArray.prototype.subarray')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.TypedArray.subarray")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Typed_arrays">JavaScript typed arrays</a></li>
 <li>{{jsxref("TypedArray")}}</li>
 <li>{{jsxref("ArrayBuffer")}}</li>
</ul>
